// NpSessionBase.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "IckarSocket.h"
#include "NpSession.h"
#include "NpUdpSession.h"

#if defined(WIN32)
#include "AsyncSocketEx.h"
#endif

#include "NpSessionBase.h"
#include "NpPacket.h"
#if defined(WIN32)
#include "shlobj.h"

HINSTANCE g_hInst = NULL;

int GetUserLocalAppPath(int nFolder, LPTSTR pszPath)
{
	typedef HRESULT (WINAPI * SHGetFolderPathProc)(
		HWND hwndOwner,
		int nFolder,
		HANDLE hToken,
		DWORD dwFlags,
		LPTSTR pszPath
	);

	HMODULE hModule = LoadLibrary("SHFolder.dll");
	if(hModule == NULL)
		return 0;

	int nRet = 0;
	SHGetFolderPathProc SHGetFolderPath = NULL;
#ifdef _UNICODE
	SHGetFolderPath = (SHGetFolderPathProc)GetProcAddress(hModule, "SHGetFolderPathW");
#else
	SHGetFolderPath = (SHGetFolderPathProc)GetProcAddress(hModule, "SHGetFolderPathA");
#endif

	if(SHGetFolderPath) {
		nRet = SHGetFolderPath(NULL, nFolder, NULL, 0, pszPath);
		strcat(pszPath, "\\GameTalk\\");
	}

	if(hModule)
		FreeLibrary(hModule);

	return nRet;
}


int CALLBACK write_packet_debug_log(const char * format, ...)
{
	// {{ va_list ----> START
	va_list vl;
	va_start(vl, format);

	char szBuff[1025];
	int len = _vsnprintf(szBuff, 1024, format, vl);
	
	va_end(vl);
	// {{ va_list -----> END

//	DLOG("%s", szBuff);

	return len;
}

int CALLBACK write_packet_log(const char * format, ...)
{
	// {{ va_list ----> START
	va_list vl;
	va_start(vl, format);

	char szBuff[1025];
	int len = _vsnprintf(szBuff, 1024, format, vl);
	
	va_end(vl);
	// {{ va_list -----> END

//	ELOG("%s", szBuff);

	return len;
}

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		{
			g_hInst = (HINSTANCE)hModule;
			
			if( CAsyncSocketEx::InitSocket() == FALSE )
				return FALSE;

			//char szBuffer[MAX_PATH+1];
			//GetModuleFileName( NULL, szBuffer, MAX_PATH );
			////GetUserLocalAppPath(CSIDL_LOCAL_APPDATA, szBuffer);
			//char * p1 = strrchr(szBuffer, '\\');
			//if( p1 != NULL )
			//{
			//	p1++;
			//	char *p2 = strchr(p1, '.');
			//	*p2 = 0;
			//	
			//	char szBuffer2[MAX_PATH];
			//	sprintf(szBuffer2, "%s_socket", p1);
			//	DLOG_INIT(szBuffer2);

			//	OutputDebugString("DLOG_INIT::szBuffer2");
			//	OutputDebugString(szBuffer2);
			//}
			//else
			//	DLOG_INIT("socket");

			fpWriteDebugLog = write_packet_debug_log;
			fpWriteErrorLog = write_packet_log;

			CSocketHelperWnd::sRegisterClass( g_hInst );
		}
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		{
			CSocketHelperWnd::sUnregisterClass();

			WSACleanup();
		}
		break;
    }

    return TRUE;
}

#endif // WIN32

void __stdcall SetFP_get_np_cmmd_str( const char * (CALLBACK *fp_get_np_cmmd_str)(USHORT usCMMD) )
{
	fpGetNpCMMD_Str = fp_get_np_cmmd_str;
}


//NPSESSIONBASE_API
IIckarSocket * __stdcall _CreateIckarSocket(_IIckarSocketEvents * pEvents, 
													bool bUseSSL,
													NC_SOCKET_TYPE nSocketType,
													LPCSTR szProxyServerAddr,
													int nProxyServerPort,
													LPCSTR szProxyUserId,
													LPCSTR szProxyUserPwd)
{
	CIckarSocket * pIckarSocket = new CIckarSocket;
	pIckarSocket->SetEvents( pEvents );
	
	return pIckarSocket;
}

//NPSESSIONBASE_API
#if defined(WIN32)
INpSession * CreateNpSession(_INpSessionEvents * pEvents, bool bUseNetworkSetting)
#else
INpSession * CreateNpSession_NpSessionBase(_INpSessionEvents * pEvents, bool bUseNetworkSetting)
#endif
{
	CNpSession * pSession = new CNpSession;
	pSession->m_bUseProxySetting = bUseNetworkSetting;
	pSession->SetEvents( pEvents );

	return pSession;
}

#if defined(WIN32)
INpUdpSession * CreateNpUdpSession(_INpUdpSessionEvents * pEvents, bool bUseNetworkSetting)
#else
INpUdpSession * CreateNpUdpSession_NpSessionBase(_INpUdpSessionEvents * pEvents, bool bUseNetworkSetting)
#endif
{
	CNpUdpSession * pSession = new CNpUdpSession;
//	pSession->m_bUseProxySetting = bUseNetworkSetting;
	pSession->SetEvents( pEvents );

	return pSession;
}

